<template>
  <v-container
    fluid
    pa-0
    ma-0
  >
    <v-card
      class="mx-auto"
      :max-width="`${vW}px`"
    >
      <v-row>
        <v-col
          class="ma-2"
          cols="1"
        >
          <v-select
            v-model="thisfy"
            :items="fys"
            label="FY"
          />
        </v-col>
        <v-col
          class="ma-2"
          cols="4"
        >
          <jlus
            :is-list="noList"
            @jluSelected="jluSelected"
          />
        </v-col>
        <v-col
          class="ma-2"
          cols="5"
        >
          <dsas
            :is-list="noList"
            @dsaSelected="dsaSelected"
          />
        </v-col>
      </v-row>

      <v-card-title>
        LOB MM Phasing
      </v-card-title>

      <v-card-subtitle>
        Use the filters to select a JLU for a FY worth of bids. Click on a line to edit.
      </v-card-subtitle>
      <v-row>
        <v-col

          class="ma-2"
        >
          <v-data-table
            :headers="headerSwitch"
            :items="phasings"
            :server-items-length="phasingsTotalItems"
            :page.sync="page"
            :items-per-page="itemsPerPage"
            class="elevation-1"
            @page-count="pageCount = $event"
          >
            <!-- eslint-disable-next-line -->
  <template v-if="$store.state.app.user.mm" v-slot:item.editPhasing="{ item }">
              <v-icon
                small
                class="mr-2"
                @click="editPhasing(item)"
              >
                mdi-pencil
              </v-icon>
            </template>
            <!-- eslint-disable-next-line -->
          <template v-slot:item.jluOrigBid="{ item }">
              {{ item.jluOrigBid | toDollars }}
            </template>
            <!-- eslint-disable-next-line -->
          <template v-slot:item.approvedBudget="{ item }">
              {{ item.approvedBudget | toDollars }}
            </template>
          </v-data-table>
        </v-col>
      </v-row>
      <!-- <v-row>
        <v-col>
          phasingsMeta: {{ phasingsMeta }}
        </v-col>
      </v-row> -->
      <!-- <div class="text-center pt-2">
        <v-pagination
          v-model="page"
          :length="pageCount"
        />
        <v-text-field
          :value="itemsPerPage"
          label="Items per page"
          type="number"
          min="-1"
          max="15"
          @input="itemsPerPage = parseInt($event, 10)"
        />
      </div> -->
      <!--
      <div>
        page: {{ page }}<br>
        pageCount: {{ pageCount }}<br>
      </div> -->
      <v-row
        justify="end"
        align="center"
      >
        <v-col
          v-if="$store.state.app.user.isAdmin"
          class="ma-3"
          cols="1"
        >
          <v-btn
            color="primary"
            dark
            class="mb-2"
            @click="addNew"
          >
            Add New
          </v-btn>
        </v-col>
        <v-col
          v-if="$store.state.app.user.mm"
          class="ma-1"
          cols="2"
        >
          <v-btn
            color="primary"
            dark
            class="mb-2"
            @click="download()"
          >
            Export Data
          </v-btn>
        </v-col>
        <v-col
          v-if="$store.state.app.user.isAdmin"
          class="ma-1"
          cols="2"
        >
          <v-btn
            color="primary"
            dark
            :loading="buildingData"
            class="mb-2"
            @click="buildNewBidData()"
          >
            Rebuild Bid Data
          </v-btn>
        </v-col>

        <v-col
          cols="3"
        >
          Total Value of Original Bids: ${{ localBidSummed | toDollars }}
        </v-col>
        <v-col
          cols="3"
        >
          Total Value of Authorised Phasings: ${{ localAuthSummed | toDollars }}
        </v-col>
      </v-row>
    </v-card>
    <v-dialog
      v-model="editedPhasingDialog"
      :max-width="`${vW}px`"
      persistent
    >
      <v-card>
        <v-card-title>
          <span class="text-h5">Edit Phasing for
            FY-{{ editedPhasing.fy }}
          </span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <!-- <v-row>
              editedPhasing: {{ editedPhasing }}
            </v-row> -->
            <v-row
              v-if="existsInDB==true"
            >
              <v-col
                cols="12"
              >
                <span
                  class="text-h5"
                  style="color: red;"
                >
                  A DSA entry for this JLU in this Financial Period already exists!
                </span>
              </v-col>
            </v-row>
            <v-row>
              <v-col
                cols="4"
              >
                <v-text-field
                  v-model="editedPhasing.romanCode"
                  :disabled="editedPhasing.id===''"
                  :readonly="editedPhasing.id!==''"
                  label="Roman Code"
                />
              </v-col>
              <v-col
                cols="4"
              >
                <v-text-field
                  v-if="editedPhasing.id!==''"
                  v-model="editedPhasing.jlu"
                  :readonly="editedPhasing.id!==''"
                  label="JLU"
                />

                <jlus
                  v-if="editedPhasing.id===''"
                  :is-list="isList"
                  @jluNew="jluNew"
                />
              </v-col>
              <v-col
                cols="4"
              >
                <v-text-field
                  v-model="editedPhasing.wbs"
                  :disabled="editedPhasing.id===''"
                  :readonly="editedPhasing.id!==''"
                  label="WBS"
                />
              </v-col>
            </v-row>
            <v-row>
              <v-col
                cols="12"

                px-5
              />
            </v-row>
            <v-row>
              <v-col
                cols="8"
              >
                <v-text-field
                  v-if="editedPhasing.id!==''"
                  v-model="editedPhasing.dsa"
                  :readonly="editedPhasing.id!==''"
                  label="DSA"
                />
                <dsas
                  v-if="editedPhasing.id===''"
                  :dsa-prop="editedPhasing.dsa"
                  :is-list="isList"
                  @dsaNew="dsaNew"
                />
              </v-col>
              <v-col
                cols="1"
              >
                <v-text-field
                  v-if="editedPhasing.id!==''"
                  v-model="editedPhasing.fy"
                  :readonly="editedPhasing.id!==''"
                  label="FY"
                />
                <v-select
                  v-if="editedPhasing.id===''"
                  v-model="editedPhasing.fy"
                  :items="fys"

                  label="FY"
                />
              </v-col>
            </v-row>
            <v-row
              justify="center"
            >
              <v-expansion-panels
                v-model="panelBids"
              >
                <v-expansion-panel>
                  <v-expansion-panel-header>
                    <v-card-subtitle>
                      <span class="text-h5">Initial JLU Bids - $
                        {{ localOriginalBudget | toDollars }}</span>
                    </v-card-subtitle>
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <v-row>
                      <v-col
                        cols="3"
                      >
                        <v-checkbox
                          v-model="editedPhasing.lockBids"
                          label="Lock Bid"
                        />
                      </v-col>
                      <v-col
                        cols="5"
                      />
                      <!-- <v-col
                        cols="4"
                      >
                        <v-text-field
                          v-model="localOriginalBudget"
                          readonly
                          reverse
                          label="Initial JLU Budget"
                        />
                      </v-col> -->
                    </v-row>

                    <v-row>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidJul"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b1')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidAug"
                          v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b2')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidSep"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b3')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidOct"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b4')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidNov"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b5')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidDec"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b6')"
                        />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidJan"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b7')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidFeb"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b8')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidMar"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b9')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidApr"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b10')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidMay"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b11')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.bidJun"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'b12')"
                        />
                      </v-col>
                    </v-row>
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
              <v-expansion-panels
                v-model="panelAuth"
                multiple
              >
                <v-expansion-panel>
                  <v-expansion-panel-header>
                    <v-card-subtitle>
                      <span class="text-h5 ">Authorised JLU Bids -
                        ${{ localApprovedBudget | toDollars }}</span>
                    </v-card-subtitle>
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <!-- <v-row>
              dynLabel:  {{ dynLabel(editedPhasing.fy, 'authJul') }}
            </v-row> -->
                    <v-row>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authJul"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a1')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authAug"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a2')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authSep"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a3')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authOct"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a4')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authNov"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a5')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authDec"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a6')"
                        />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authJan"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a7')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authFeb"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a8')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authMar"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a9')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authApr"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a10')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authMay"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a11')"
                        />
                      </v-col>
                      <v-col
                        cols="2"
                      >
                        <v-text-field
                          v-model="editedPhasing.authJun"
                          :v-mask="mask"
                          reverse
                          :label="dynLabel(editedPhasing.fy, 'a12')"
                        />
                      </v-col>
                    </v-row>
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
              <v-expansion-panels
                v-model="panelHistory"
              >
                <v-expansion-panel>
                  <v-expansion-panel-header>
                    <v-card-subtitle>
                      <span class="text-h5">Bid History</span>
                    </v-card-subtitle>
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <v-row>
                      <v-col

                        class="ma-2"
                      >
                        <v-data-table
                          :headers="headersLog"
                          :items="logData"
                          :server-items-length="logTotalItems"
                          :page.sync="logPage"
                          :items-per-page="itemsPerPage"
                          class="elevation-1"
                          @page-count="pageCount = $event"
                        >
                          <!-- eslint-disable-next-line -->
                        <template v-slot:item.="{ item }">
                            {{ item.entryDate | betterDate }}
                          </template>
                        </v-data-table>
                      </v-col>
                    </v-row>
                    <!-- <v-row>
                      logData: {{ logData }}
                    </v-row> -->
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
            </v-row>
            <v-spacer />
          </v-container>
        </v-card-text>
        <!-- editedPhasing: {{editedPhasing}} -->
        <v-card-actions>
          <v-spacer />
          <v-btn
            v-if="editedPhasing.id!=='' &&
              $store.state.app.user.mm===true"
            color="red darken-1"
            text
            @click="deletePhasing()"
          >
            Delete
          </v-btn>
          <v-btn
            color="blue darken-1"
            text
            @click="closeEditPhasing()"
          >
            Cancel
          </v-btn>
          <v-btn
            v-if="editedPhasing.id!=='' &&
              $store.state.app.user.mm===true"
            color="blue darken-1"
            :disabled="editedPhasing.dsa==='' ||
              editedPhasing.jluId==='' ||
              editedPhasing.fy===''"
            text
            @click="openSaveEditPhasingComment()"
          >
            Save
          </v-btn>
          <v-btn
            v-if="editedPhasing.id==='' &&
              $store.state.app.user.mm===true"
            color="blue darken-1"
            :disabled="(editedPhasing.dsa==='' ||
              editedPhasing.jluId==='' ||
              editedPhasing.fy==='') ||
              existsInDB===true"
            text
            @click="openSaveEditPhasingComment()"
          >
            Add
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog
      v-model="deleteConfirm"
      :max-width="`${vWDel}px`"
      persistent
    >
      <v-card>
        <v-card-title>
          <span class="text-h5">Delete Bid {{ editedPhasing.jlu }}  for
            {{ editedPhasing.dsa }}<br> in FY {{ editedPhasing.fy }}
          </span>
        </v-card-title>

        <v-card-text>
          Are you sure?
        </v-card-text>
        <!-- editedPhasing:{{ editedPhasing }} -->
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="blue darken-1"
            text
            @click="cancelDelete()"
          >
            Cancel
          </v-btn>
          <v-btn
            v-if="editedPhasing.id!=='' &&
              $store.state.app.user.mm===true"
            color="red darken-1"
            text
            @click="confirmDelete()"
          >
            Confirm
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog
      v-model="saveCommentDialog"
      :max-width="`${vWCom}px`"
      persistent
    >
      <v-card>
        <v-container>
          <v-row>
            <h3>
              <span class="text-h5">Add Comment
              </span>
            </h3>
          </v-row>

          <v-row>
            <v-col
              class="ma-3"
            >
              For {{ changeToPhase }}
            </v-col>
          </v-row>
          <v-row>
            <v-col
              class="ma-3"
            >
              <v-textarea
                v-model="explForSave"
                label="Explanation for change"
              />
            </v-col>
          </v-row>
        </v-container>

        <v-card-actions>
          <v-btn
            color="blue darken-1"
            text
            @click="cancelComment()"
          >
            Cancel
          </v-btn>
          <v-btn
            color="red darken-1"
            text
            @click="saveEditPhasing()"
          >
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-snackbar
      v-model="snackbar"
      :timeout="sbTimeout"
      top
    >
      {{ snackText }}

      <template #action="{ attrs }">
        <v-btn
          color="primary"
          text
          v-bind="attrs"
          @click="snackbar = false"
        >
          Close
        </v-btn>
      </template>
    </v-snackbar>
  </v-container>
</template>

<script>
// @ is an alias to /src
import { cloneDeep, isEqual, orderBy } from 'lodash';
import createNumberMask from 'text-mask-addons/dist/createNumberMask';
import { diff } from 'deep-diff';
// eslint-disable-next-line
import { patch, post, get, getBulkData, exportBulkExcel, del } from 'kyd-utils';
// eslint-disable-next-line
import { dateShortFromLong, dateFddmmmyy, dateFyymmdd } from '../localUtils';
import jlus from '../components/jlus';
import dsas from '../components/dsas';
// eslint-disable-next-line
const currencyMask = createNumberMask({
  prefix: '',
  allowDecimal: false,
  includeThousandsSeparator: true,
  allowNegative: false,
});

export default {
  name: 'Home',
  components: {
    jlus,
    dsas,
  },
  filters: {
    toDollars(val) {
      return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
    },
  },
  data: () => ({
    snackbar: false,
    snackText: '',
    sbTimeout: 2000,
    buildingData: false,
    deleteConfirm: false,
    saveCommentDialog: false,
    changeToPhase: '',
    explForSave: '',
    mask: currencyMask,
    show: false,
    noList: false,
    isList: true,
    existsInDB: false,
    panelBids: [0, 1],
    panelAuth: [1, 0],
    panelHistory: [0, 1],
    localBidSummed: 0,
    localAuthSummed: 0,
    headers: [
      {
        text: 'Roman Code',
        align: 'start',
        width: '10%',
        value: 'romanCode',
      },
      {
        text: 'JLU',
        align: 'start',
        width: '10%',
        value: 'jlu',
      },
      {
        text: 'DSA',
        width: '30%',
        value: 'dsa',
      },
      {
        text: 'WBS',
        align: 'start',
        width: '10%',
        value: 'wbs',
      },
      {
        text: 'JLU Original Bid',
        align: 'end',
        width: '15%',
        value: 'jluOrigBid',
      },
      {
        text: 'Approved Budget',
        align: 'end',
        width: '15%',
        value: 'approvedBudget',
      },
      {
        text: 'Edit Phasing',
        align: 'center',
        width: '10%',
        value: 'editPhasing',
      },
    ],
    headersLog: [
      {
        text: 'Date',
        align: 'start',
        width: '15%',
        value: 'entryDate',
      },
      {
        text: 'Change By',
        align: 'start',
        width: '10%',
        value: 'changeBy',
      },
      {
        text: 'Change',
        width: '20%',
        value: 'change',
      },
      {
        text: 'Explanation',
        width: '20%',
        value: 'explanation',
      },
      {
        text: 'FY',
        align: 'start',
        width: '5%',
        value: 'fy',
      },
      {
        text: 'JLU',
        align: 'start',
        width: '10%',
        value: 'jlu',
      },
      {
        text: 'DSA',
        align: 'start',
        width: '20%',
        value: 'dsa',
      },

    ],
    headersNoEdit: [
      {
        text: 'Roman Code',
        align: 'start',
        width: '10%',
        value: 'romanCode',
      },
      {
        text: 'JLU',
        align: 'start',
        width: '10%',
        value: 'jlu',
      },
      {
        text: 'DSA',
        width: '30%',
        value: 'dsa',
      },
      {
        text: 'WBS',
        align: 'start',
        width: '10%',
        value: 'wbs',
      },
      {
        text: 'JLU Original Bid',
        align: 'end',
        width: '15%',
        value: 'jluOrigBid',
      },
      {
        text: 'Approved Budget',
        align: 'end',
        width: '15%',
        value: 'approvedBudget',
      },
      {
        text: 'View Phasing',
        align: 'center',
        width: '10%',
        value: 'editPhasing',
      },
    ],
    headersDL: [
      {
        title: 'Roman Code',
        key: 'romanCode',
      },
      {
        title: 'JLU',
        key: 'jlu',
      },
      {
        title: 'DSA',
        key: 'dsa',
      },
      {
        title: 'WBS',
        key: 'wbs',
      },
      {
        title: 'FY',
        key: 'fy',
      },
      {
        title: 'Authorised Jul',
        type: 'currency',
        key: 'authJul',
      },
      {
        title: 'Authorised Aug',
        type: 'currency',
        key: 'authAug',
      },
      {
        title: 'Authorised Sep',
        type: 'currency',
        key: 'authSep',
      },
      {
        title: 'Authorised Oct',
        type: 'currency',
        key: 'authOct',
      },
      {
        title: 'Authorised Nov',
        type: 'currency',
        key: 'authNov',
      },
      {
        title: 'Authorised Dec',
        type: 'currency',
        key: 'authDec',
      },
      {
        title: 'Authorised Jan',
        type: 'currency',
        key: 'authJan',
      },
      {
        title: 'Authorised Feb',
        type: 'currency',
        key: 'authFeb',
      },
      {
        title: 'Authorised Mar',
        type: 'currency',
        key: 'authMar',
      },
      {
        title: 'Authorised Apr',
        type: 'currency',
        key: 'authApr',
      },
      {
        title: 'Authorised May',
        type: 'currency',
        key: 'authMay',
      },
      {
        title: 'Authorised Jun',
        type: 'currency',
        key: 'authJun',
      },
      {
        title: 'Unit Bid Jul',
        type: 'currency',
        key: 'bidJul',
      },
      {
        title: 'Unit Bid Aug',
        type: 'currency',
        key: 'bidAug',
      },
      {
        title: 'Unit Bid Sep',
        type: 'currency',
        key: 'bidSep',
      },
      {
        title: 'Unit Bid Oct',
        type: 'currency',
        key: 'bidOct',
      },
      {
        title: 'Unit Bid Nov',
        type: 'currency',
        key: 'bidNov',
      },
      {
        title: 'Unit Bid Dec',
        type: 'currency',
        key: 'bidDec',
      },
      {
        title: 'Unit Bid Jan',
        type: 'currency',
        key: 'bidJan',
      },
      {
        title: 'Unit Bid Feb',
        type: 'currency',
        key: 'bidFeb',
      },
      {
        title: 'Unit Bid Mar',
        type: 'currency',
        key: 'bidMar',
      },
      {
        title: 'Unit Bid Apr',
        type: 'currency',
        key: 'bidApr',
      },
      {
        title: 'Unit Bid May',
        type: 'currency',
        key: 'bidMay',
      },
      {
        title: 'Unit Bid Jun',
        type: 'currency',
        key: 'bidJun',
      },
      {
        title: 'JLU Original Bid',
        key: 'jluOrigBid',
        type: 'currency',
      },
      {
        title: 'Approved Budget',
        key: 'approvedBudget',
        type: 'currency',
      },
      {
        title: 'Last Modified',
        key: 'lastModified',
      },
      {
        title: 'Last Modified By',
        key: 'lastModifiedBy',
      },
    ],
    editedPhasing: {
      id: '',
      jluId: '',
      jlu: '',
      romanCode: '',
      fy: '',
      lockBids: false,
      dsa: '',
      wbs: '',
      authJul: 0,
      authAug: 0,
      authSep: 0,
      authOct: 0,
      authNov: 0,
      authDec: 0,
      authJan: 0,
      authFeb: 0,
      authMar: 0,
      authApr: 0,
      authMay: 0,
      authJun: 0,
      bidJul: 0,
      bidAug: 0,
      bidSep: 0,
      bidOct: 0,
      bidNov: 0,
      bidDec: 0,
      bidJan: 0,
      bidFeb: 0,
      bidMar: 0,
      bidApr: 0,
      bidMay: 0,
      bidJun: 0,
    },
    preEditPhasing: {},
    defEditedPhasing: {
      id: '',
      jluId: '',
      jlu: '',
      romanCode: '',
      fy: '',
      lockBids: false,
      dsa: '',
      wbs: '',
      authJul: 0,
      authAug: 0,
      authSep: 0,
      authOct: 0,
      authNov: 0,
      authDec: 0,
      authJan: 0,
      authFeb: 0,
      authMar: 0,
      authApr: 0,
      authMay: 0,
      authJun: 0,
      bidJul: 0,
      bidAug: 0,
      bidSep: 0,
      bidOct: 0,
      bidNov: 0,
      bidDec: 0,
      bidJan: 0,
      bidFeb: 0,
      bidMar: 0,
      bidApr: 0,
      bidMay: 0,
      bidJun: 0,
    },
    pageCount: 0,
    itemsPerPage: 10,
    editedPhasingDialog: false,
    editedIndex: -1,
    months: [
      'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
    ],
    fys: ['1920', '2021', '2122', '2223', '2324'],
    thisfy: '2223',
  }),
  computed: {
    vW: {
      get() {
        return this.$store.state.app.vWH.x * 0.85;
      },
    },
    vWDel: {
      get() {
        return this.$store.state.app.vWH.x * 0.4;
      },
    },
    vWCom: {
      get() {
        return this.$store.state.app.vWH.x * 0.6;
      },
    },
    user() {
      return cloneDeep(this.$store.getters['app/user']);
    },
    localApprovedBudget() {
      const editP = cloneDeep(this.editedPhasing);
      const authJul = (editP.authJul == null || editP.authJul === undefined)
        ? 0 : this.deDollar(editP.authJul);
      const authAug = (editP.authAug == null || editP.authAug === undefined)
        ? 0 : this.deDollar(editP.authAug);
      const authSep = (editP.authSep == null || editP.authSep === undefined)
        ? 0 : this.deDollar(editP.authSep);
      const authOct = (editP.authOct == null || editP.authOct === undefined)
        ? 0 : this.deDollar(editP.authOct);
      const authNov = (editP.authNov == null || editP.authNov === undefined)
        ? 0 : this.deDollar(editP.authNov);
      const authDec = (editP.authDec == null || editP.authDec === undefined)
        ? 0 : this.deDollar(editP.authDec);
      const authJan = (editP.authJan == null || editP.authJan === undefined)
        ? 0 : this.deDollar(editP.authJan);
      const authFeb = (editP.authFeb == null || editP.authFeb === undefined)
        ? 0 : this.deDollar(editP.authFeb);
      const authMar = (editP.authMar == null || editP.authMar === undefined)
        ? 0 : this.deDollar(editP.authMar);
      const authApr = (editP.authApr == null || editP.authApr === undefined)
        ? 0 : this.deDollar(editP.authApr);
      const authMay = (editP.authMay == null || editP.authMay === undefined)
        ? 0 : this.deDollar(editP.authMay);
      const authJun = (editP.authJun == null || editP.authJun === undefined)
        ? 0 : this.deDollar(editP.authJun);
      const total = Number(authJul) + Number(authAug) + Number(authSep)
      + Number(authOct) + Number(authNov)
      + Number(authDec) + Number(authJan) + Number(authFeb) + Number(authMar)
      + Number(authApr) + Number(authMay)
      + Number(authJun);
      return total;
    },
    localOriginalBudget() {
      const editP = cloneDeep(this.editedPhasing);
      const bidJul = (editP.bidJul == null || editP.bidJul === undefined)
        ? 0 : this.deDollar(editP.bidJul);
      const bidAug = (editP.bidAug == null || editP.bidAug === undefined)
        ? 0 : this.deDollar(editP.bidAug);
      const bidSep = (editP.bidSep == null || editP.bidSep === undefined)
        ? 0 : this.deDollar(editP.bidSep);
      const bidOct = (editP.bidOct == null || editP.bidOct === undefined)
        ? 0 : this.deDollar(editP.bidOct);
      const bidNov = (editP.bidNov == null || editP.bidNov === undefined)
        ? 0 : this.deDollar(editP.bidNov);
      const bidDec = (editP.bidDec == null || editP.bidDec === undefined)
        ? 0 : this.deDollar(editP.bidDec);
      const bidJan = (editP.bidJan == null || editP.bidJan === undefined)
        ? 0 : this.deDollar(editP.bidJan);
      const bidFeb = (editP.bidFeb == null || editP.bidFeb === undefined)
        ? 0 : this.deDollar(editP.bidFeb);
      const bidMar = (editP.bidMar == null || editP.bidMar === undefined)
        ? 0 : this.deDollar(editP.bidMar);
      const bidApr = (editP.bidApr == null || editP.bidApr === undefined)
        ? 0 : this.deDollar(editP.bidApr);
      const bidMay = (editP.bidMay == null || editP.bidMay === undefined)
        ? 0 : this.deDollar(editP.bidMay);
      const bidJun = (editP.bidJun == null || editP.bidJun === undefined)
        ? 0 : this.deDollar(editP.bidJun);
      const total = Number(bidJul) + Number(bidAug) + Number(bidSep)
      + Number(bidOct) + Number(bidNov)
      + Number(bidDec) + Number(bidJan) + Number(bidFeb) + Number(bidMar)
      + Number(bidApr) + Number(bidMay)
      + Number(bidJun);
      return total;
    },
    phasings() {
      let p = this.$store.state.app.phasings;
      // console.log('the p', p);
      p = p.map((x) => ({
        id: x.id,
        jluId: x.jluId,
        romanCode: x.romanCode,
        jlu: x.jlu,
        dsa: x.dsa,
        wbs: x.wbs,
        jluOrigBid: x.jluOrigBid,
        approvedBudget: x.approvedBudget,
        fy: x.fy,
        lockBids: x.lockBids,
        authJul: x.authJul,
        authAug: x.authAug,
        authSep: x.authSep,
        authOct: x.authOct,
        authNov: x.authNov,
        authDec: x.authDec,
        authJan: x.authJan,
        authFeb: x.authFeb,
        authMar: x.authMar,
        authApr: x.authApr,
        authMay: x.authMay,
        authJun: x.authJun,
        bidJul: x.bidJul,
        bidAug: x.bidAug,
        bidSep: x.bidSep,
        bidOct: x.bidOct,
        bidNov: x.bidNov,
        bidDec: x.bidDec,
        bidJan: x.bidJan,
        bidFeb: x.bidFeb,
        bidMar: x.bidMar,
        bidApr: x.bidApr,
        bidMay: x.bidMay,
        bidJun: x.bidJun,
      }));
      return p;
    },
    headerSwitch() {
      const { mm } = this.$store.state.app.user;
      let h = this.headers;
      if (mm === false) {
        h = this.headersNoEdit;
      }
      return h;
    },
    logData() {
      let l = this.$store.state.app.log;
      // console.log('the log data', l);
      l = l.map((x) => ({
        id: x.id,
        jluId: x.jluId,
        jlu: x.jlu,
        dsa: x.dsa,
        fy: x.fy,
        entryDate: x.entryDate,
        changeBy: x.changeBy,
        change: x.change,
        explanation: x.explanation,
      }));
      return l;
    },
    phasingsMeta() {
      const t = cloneDeep(this.$store.state.app.phasingsMeta);
      return t;
    },
    phasingsTotalItems() {
      const t = this.phasingsMeta.totalItems;
      return t;
    },
    page: {
      get() {
        const t = this.$store.state.app.phasingsMeta.page;
        return t;
      },
      set(v, ov) {
        if (!isEqual(v, ov)) {
          // eslint-disable-next-line
          const payload = {
            page: v,
          };
          // console.log('in page set', payload);
          this.$store.commit('app/SET_PHASINGS_META', payload);
        }
      },
    },
    logMeta() {
      const t = cloneDeep(this.$store.state.app.logMeta);
      return t;
    },
    logTotalItems() {
      const t = this.logMeta.totalItems;
      return t;
    },
    logPage: {
      get() {
        const t = this.$store.state.app.logMeta.page;
        return t;
      },
      set(v, ov) {
        if (!isEqual(v, ov)) {
          // eslint-disable-next-line
          const payload = {
            page: v,
          };
          // console.log('in page set', payload);
          this.$store.commit('app/SET_LOG_META', payload);
        }
      },
    },
    jluId: {
      get() {
        const t = this.editedPhasing.jluId;
        return t;
      },
      set(v) {
        this.editedPhasing.jluId = v;
      },
    },
    dsa: {
      get() {
        const t = this.editedPhasing.dsa;
        return t;
      },
      set(v) {
        this.editedPhasing.dsa = v;
      },
    },
    fy: {
      get() {
        const t = this.editedPhasing.fy;
        return t;
      },
      set(v) {
        this.editedPhasing.fy = v;
      },
    },
    bidJul: {
      get() {
        const t = this.editedPhasing.bidJul;
        return t;
      },
      set(v) {
        this.editedPhasing.bidJul = v;
      },
    },
  },
  watch: {
    page: {
      deep: true,
      handler(nv, ov) {
        if (nv !== ov) {
          // console.log('the page has changed', nv);
          this.refreshTable();
        }
      },
    },
    logPage: {
      deep: true,
      handler(nv, ov) {
        if (nv !== ov) {
          // console.log('the page has changed', nv);
          this.refreshLog();
        }
      },
    },
    jluId: {
      handler(v) {
        if (v !== '') {
        // console.log('the page has changed', nv);
          this.runAndCheckExists();
        }
      },
      immediate: true,
    },
    dsa: {
      handler(v) {
        if (v !== '') {
        // console.log('the page has changed', nv);
          this.runAndCheckExists();
        }
      },
      immediate: true,
    },
    fy: {
      handler(v) {
        if (v !== '') {
        // console.log('the page has changed', nv);
          this.runAndCheckExists();
        }
      },
      immediate: true,
    },
    // bidJul: {
    //   handler(v) {
    //     if (v !== '') {
    //       this.bidJul = v.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
    //     }
    //   },
    //   immediate: true,
    // },
    thisfy: {
      handler(v) {
        if (v !== '') {
        // console.log('the page has changed', nv);
          this.fySelected(v);
        }
      },
      immediate: true,
    },
  },
  mounted() {
    this.setFY();
    // this.refreshTable();
  },
  methods: {
    cancelComment() {
      this.explForSave = '';
      this.changeToPhase = '';
      this.saveCommentDialog = false;
    },
    openSaveEditPhasingComment() {
      const newPh = this.editedPhasing;
      const oldPh = this.preEditPhasing;
      this.changeToPhase = this.deepdif(oldPh, newPh);
      if (this.changeToPhase !== '') {
        this.saveCommentDialog = true;
      } else {
        // const snackMsg = 'No change detected';
        this.refreshTable();
        this.closeEditPhasing();
      }
    },
    async saveEditPhasing() {
      const payload = this.editedPhasing;
      // const oldPh = this.preEditPhasing;
      // const changeRecord = this.deepdif(oldPh, payload);
      const payloadC = {
        change: this.changeToPhase,
        explanation: this.explForSave,
        jluId: payload.jluId,
        fy: payload.fy,
        dsa: payload.dsa,
      };
      const x = Object.entries(payload)
        .reduce((acc, [key, value]) => (value !== '' && value !== undefined ? { ...acc, [key]: this.deDollar(value) } : acc), {});
      const idV = payload.id;
      const filter = {
        filter: [{ key: 'id', equals: idV }],
      };
      const params = { params: filter };
      const payloadF = Object.entries(x)
        .reduce((acc, [key, value]) => (key !== 'jluOrigBid'
          && key !== 'approvedBudget'
          && key !== 'romanCode'
          && key !== 'jlu'
          ? { ...acc, [key]: value } : acc), {});
      const isEdit = (payload.id !== '');

      if (isEdit === true) {
        // console.log('about to save', payloadF);
        await patch(
          '/phasings-patch',
          payloadF,
          params,
        );
        // console.log('post patch', p);
      } else {
        // const params = { params: this.phasingsMeta };
        await post(
          '/phasings-post',
          [payloadF],
        );
      }
      // console.log('item to save', payload);
      // console.log('the log obj', payloadC);
      await post(
        '/change-log-post',
        [payloadC],
      );
      this.refreshTable();
      this.cancelComment();
      this.closeEditPhasing();
    },
    deDollar(v) {
      let d = '';
      if (v !== null && v !== undefined) {
        d = v.toString().replace(/[`~!@#$%^&*()_|+=?;:'",.<>]/gi, '');
      }
      return d;
    },
    async runAndCheckExists() {
      const id = cloneDeep(this.editedPhasing.id);
      if (id === '') {
        const j = this.jluId;
        const d = this.dsa;
        const f = this.fy;
        if (j !== '' && d !== '' && f !== '') {
          // console.log(`go check new entry with jlu ${j}, dsa ${d}, fy ${f} `);
          // eslint-disable-next-line
          const payload = {
            totalItems: 0,
            itemsPerPage: 10,
            sort: [{ asc: true, key: 'dsa' }],
            // eslint-disable-next-line
            filter: [{ key: 'jluId', equals: j }, { key: 'dsa', equals: d }, { key: 'fy', equals: f }],
            page: 1,
          };
          const response = await get('/existing-entry', { params: payload });
          // const response = await get('jlus');
          if (response.data !== undefined && response.data.length > 0) {
            // console.log('the response', response);
            this.existsInDB = true;
          } else {
            this.existsInDB = false;
          }
        }
      }
    },
    deepdif(oldPh, newPh) {
      let diffP = diff(oldPh, newPh);

      const usr = this.user.name;
      let dN = 0;
      let changesP = '';
      let diffText = '';
      if (diffP !== undefined && diffP.length > 0) {
        diffP = diffP.filter((l) => l.rhs !== undefined && l.lhs !== undefined);
        if (diffP !== undefined && diffP.length > 0) {
          // eslint-disable-next-line
          const diffDistilled = diffP.filter((d) => d.lhs.toString() !== this.deDollar(d.rhs).toString());

          if (diffDistilled !== undefined && diffDistilled.length > 0) {
            dN = diffDistilled.length;
            changesP = diffDistilled.map((dets) => `${dets.path[0]}  old: ${dets.lhs} new: ${dets.rhs}`);
            changesP = changesP.toString();
          }

          switch (dN) {
            case 0:
              diffText = 'no changes';
              break;
            case 1:
              diffText = `Phasing Edit - ${usr} made ${dN} change - ${changesP}`;
              break;
            default:
              diffText = `Phasing Edit - ${usr} made ${dN} changes - ${changesP}`;
          }
        // console.log(diffText);
        }
      }
      console.log('the dif Text', diffText);
      return diffText;
    },
    dynLabel(fy, fld) {
      // const fld = 'bidJul'
      const fL = fld.length;
      const act = (fld.slice(0, 1) === 'b') ? 'JLU Bid' : 'Authorised Bid';
      const MthIdx = Number(fld.slice(1, fL)) - 1;
      const fyL = (MthIdx <= 5) ? fy.slice(0, 2) : fy.slice(2, 4);
      const Mth = this.months[MthIdx];
      const t = `${act} ${Mth} ${fyL}`;

      return t;
    },
    async   setFY() {
      const fyD = await get('/fy');
      const fyArr = [];
      let fyElm = '';
      if (fyD !== undefined && fyD.statusText === 'OK') {
        let d = fyD.data;
        d = orderBy(d, 'fy', 'ASC');
        d.forEach((f) => {
          fyElm = f.fy;
          fyArr.push(fyElm);
        });
        this.fys = fyArr;
      }
      // console.log('the fy', fyD);
      let dte = new Date();
      const z = dte.getTimezoneOffset() * 60 * 1000;
      dte -= z;
      dte = new Date(dte);
      const s2122 = new Date('2021-07-01 00:00:00');
      const e2122 = new Date('2022-06-30 23:59:59');
      const s2223 = new Date('2022-07-01 00:00:00');
      const e2223 = new Date('2023-06-30 23:59:59');
      const s2324 = new Date('2023-07-01 00:00:00');
      const e2324 = new Date('2024-06-30 23:59:59');
      let fy = '2223';
      if (dte > s2122 && dte < e2122) {
        fy = '2122';
      }
      if (dte > s2223 && dte < e2223) {
        fy = '2223';
      }
      if (dte > s2324 && dte < e2324) {
        fy = '2324';
      }

      // console.log(`the fy is ${fy}.`, fyD);
      this.thisfy = fy;
    },
    async buildNewBidData() {
      this.buildingData = true;
      const bidD = await get('/build-phasings-bid');

      if (bidD !== undefined && bidD.statusText === 'OK') {
        const cnt = bidD.cnt.rowCnt;
        // console.log('The cnt', bidD.cnt.rowCnt);
        this.snackText = `New Phasing Bid Data Built with ${cnt} records`;
      } else {
        this.snackText = 'Something went wrong';
      }
      this.snackbar = true;
      this.buildingData = false;
    },
    refreshTable() {
      const payload = {
        ...this.phasingsMeta,
      };
      this.$store.dispatch('app/grabTable', payload);
      this.getSummedFigures();
      // console.log('the payload for refresh', payload);
    },
    async getSummedFigures() {
      const f = cloneDeep(this.$store.state.app.phasingsMeta.filter);
      const idxDSA = f.findIndex((x) => x.key === 'dsa');
      const idxFY = f.findIndex((x) => x.key === 'fy');
      const idxJ = f.findIndex((x) => x.key === 'jluId');
      const payload = {
        dsa: f[idxDSA].equals,
        jluId: f[idxJ].equals,
        fy: f[idxFY].equals,
      };
      // console.log('the payload', payload);
      const summed = await get('/phasings-summed', { params: payload });
      if (summed.statusText === 'OK') {
        this.localBidSummed = summed.data.bid;
        this.localAuthSummed = summed.data.auth;
      } else {
        this.localBidSummed = 0;
        this.localAuthSummed = 0;
      }
      // console.log('the summed', summed);
    },
    refreshLog() {
      const Ph = this.editedPhasing;
      const j = Ph.jluId;
      const d = Ph.dsa;
      const y = Ph.fy;
      const fil = [{ key: 'jluId', equals: j }, { key: 'dsa', equals: d }, { key: 'fy', equals: y }];
      const payload = {
        ...this.logMeta,
        filter: fil,
      };
      // console.log('the payload for refresh Log', payload);
      this.$store.dispatch('app/grabChangeLog', payload);
    },
    addNew() {
      this.editedPhasing = cloneDeep(this.defEditedPhasing);
      this.editedIndex = -1;
      this.editedPhasingDialog = true;
    },
    editPhasing(item) {
      console.log('the item', item);
      // this.editedIndex = this.phasings.indexOf(item);
      // this.editedPhasing = item;
      this.editedIndex = this.phasings.indexOf(item);
      const itemSet = {
        ...this.defEditedPhasing,
        ...item,
      };

      this.editedPhasing = { ...itemSet };
      this.preEditPhasing = { ...itemSet };
      this.editedPhasingDialog = true;
      this.refreshLog();
    },
    download() {
      const url = '/phasings';
      let d = new Date();
      d = dateFyymmdd(d);
      // const z = d.getTimezoneOffset() * 60 * 1000;
      // d -= z;
      // d = new Date(d).toISOString().slice(0, 10);
      const options = {
        ...this.phasingsMeta,
        itemsPerPage: 500,
        title: `${d} - Phasings Data `,
        creator: this.$store.state.app.user.name,
        headers: this.headersDL,
        params: { filter: this.phasingsMeta.filter },
      };

      exportBulkExcel(url, options);
      // get('/phasings', { params: payload })
      // console.log('downloading', url, options);
    },
    closeEditPhasing() {
      this.editedIndex = -1;
      this.panelBids = [0, 1];
      this.panelAuth = [1, 0];
      this.panelHistory = [0, 1];
      this.existsInDB = false;

      const defP = JSON.parse(JSON.stringify(cloneDeep(this.defEditedPhasing)));
      // console.log('the defP is', defP);
      this.editedPhasing = null;
      this.editedPhasing = { ...defP };
      this.preEditPhasing = null;
      this.preEditPhasing = { ...defP };
      // const d = { ...cloneDeep(this.editedPhasing) };
      // console.log('the edited Phasing is', d);
      this.editedPhasingDialog = false;
    },

    deletePhasing() {
      this.deleteConfirm = true;
    },
    cancelDelete() {
      this.deleteConfirm = false;
    },
    async confirmDelete() {
      const id = cloneDeep(this.editedPhasing.id);
      // console.log('step into delete', id);
      if (id !== '') {
        const payload = {
          toDelete: id,
        };
        await post('/phasings-delete', payload);
      }
      this.refreshTable();
      this.deleteConfirm = false;
      this.editedPhasingDialog = false;
    },
    fySelected(v) {
      const f = this.$store.state.app.phasingsMeta.filter;
      const idx = f.findIndex((x) => x.key === 'fy');
      const payload = {
        idx,
        val: v,
      };
      this.$store.commit('app/SET_PHASINGS_FILTER_META', payload);
      this.page = 1;
      // console.log('I think the fy changed', payload);
      this.refreshTable();
    },
    jluSelected(v) {
      const f = this.$store.state.app.phasingsMeta.filter;
      const idx = f.findIndex((x) => x.key === 'jluId');
      const payload = {
        idx,
        val: v,
      };
      this.$store.commit('app/SET_PHASINGS_FILTER_META', payload);
      this.page = 1;
      // console.log('I think the jlu changed', payload);
      this.refreshTable();
    },
    jluNew(v) {
      // console.log('the new jlu is ', v);
      this.editedPhasing.jluId = v;
    },
    dsaSelected(v) {
      const f = this.$store.state.app.phasingsMeta.filter;
      const idx = f.findIndex((x) => x.key === 'dsa');
      const payload = {
        idx,
        val: v,
      };
      this.page = 1;
      this.$store.commit('app/SET_PHASINGS_FILTER_META', payload);
      // console.log('I think the dsa changed', payload);
      this.refreshTable();
    },
    dsaNew(v) {
      // console.log('the new dsa is ', v);
      this.editedPhasing.dsa = v;
    },
  },
};
</script>
